
#include <p30f6014A.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "../library/motor_led/e_epuck_ports.h"
#include "../library/motor_led/e_init_port.h"
#include "../library/motor_led/e_led.h"
#include "../library/a_d/e_prox.h"
#include "../library/uart/e_uart_char.h"
#include "e_compass.h"

void initialize() {
  // inicializacia
  e_init_port();
  e_init_prox();
  e_init_uart1();
  e_send_uart1_char("\f\a", 2);	
  e_init_compass();

  // v pripade zapnutia resetnem (kvoli problemom s niektorymi robotmi)
  if (RCONbits.POR) {
	RCONbits.POR = 0;
	__asm__ volatile ("reset");
  }
}

int main() {
  // inicializacia
  initialize();
  
  // Loop
  unsigned int ledIndex = 0;
  while (1) {
    // poslanie hodnot zo senzorov
    long i;

    char response[255], buffer[255];
    unsigned char compass[6];
    e_read_compass(compass);
    strcpy(response, "Compass: ");

    for (i = 0; i < 6; i++) {
      sprintf(buffer, "%d", compass[i]);
      strcat(response, buffer);
      strcat(response, " ");
    }
    strcat(response, "\r\n");
    e_send_uart1_char(response, strlen(response));

    // blikanie  	
  	for(i = 0; i < 500000; i++) {
  	  asm("NOP");
  	}
  	e_set_led(ledIndex, 2); 
    ledIndex++;
    ledIndex %= 8;
  }	
	
}

