

#include "Actuators.h"

#include "../library/motor_led/e_led.h"
#include "../library/motor_led/e_motors.h"
#include "../library/a_d/e_prox.h"

void turn(double angle) {  
  int direction = 1;
  if (angle > 180) {
    angle = 360 - angle;
    direction = -1;
  }
  drive(1000 * direction, -1000 * direction, STEPS_FOR_FULL_CIRCLE * angle / 360.0);
}

void move(double distance) {
  int direction = 1;
  if (distance < 0) {
    distance = -distance;
    direction = -1;
  }
  drive(direction * 1000, direction * 1000, MM_TO_STEPS(distance * 10));
}

TCellInfo getPercept() {
    e_set_led(8, 0);
    int value, left, right, limit = 140;
    double d = 3.2;
    TCellInfo result = 0;

	turn(45);
    move(d);
    
    value = e_get_prox(6);
	if(value > limit)	{
        result |= DIRECTION_UP;
    } 

    value = e_get_prox(1);
    right = value;
	if(value > limit)	{
        result |= DIRECTION_RIGHT;
    }   

    move(-2*d);

    value = e_get_prox(4);
    left = value;
	if(value > limit)	{
        result |= DIRECTION_LEFT;
    } 

    value = e_get_prox(3);
	if(value > limit)	{
        result |= DIRECTION_DOWN;
    }  
/*
    value = e_get_prox(5);
	if(value > limit)	{
        result |= DIRECTION_UP;
    } 

    value = e_get_prox(2);
	if(value > limit)	{
		 result |= DIRECTION_DOWN;
    }    
*/
    if (result & DIRECTION_DOWN)   	e_set_led(4 , 1);
    if (result & DIRECTION_UP)   	e_set_led(0 , 1);
    if (result & DIRECTION_LEFT)   	e_set_led(6 , 1);
    if (result & DIRECTION_RIGHT)   e_set_led(2 , 1);

   move(d);
    turn(316.1);
/*
    value = (e_get_prox(7)>e_get_prox(0))?e_get_prox(7):e_get_prox(0);
    if (value>200) {
          move(-1*(value)/400);
    }  
*/
    return result;
}
