
#include "Hashing.h"
#include "Maze.h"

unsigned int hashXY(unsigned int x, unsigned int y) {
  return x + y * MAX_MAZE_SIZE;
}

void hashReverse(unsigned int hash, unsigned int *x, unsigned int *y) {
  *x = hash % MAX_MAZE_SIZE;
  *y = hash / MAX_MAZE_SIZE;
}

void hashSetInitialize(THashSet set) {
  unsigned int i;
  for (i = 0; i < HASH_SET_CAPACITY; i++) {
    set[i] = 0;
  }
}

void hashSetAdd(THashSet set, unsigned int hash) {
  unsigned int arrayIndex = hash / 8, byteIndex = hash % 8;
  unsigned char mask = 1 << (7 - byteIndex);
  if (arrayIndex < HASH_SET_CAPACITY) {
    set[arrayIndex] |= mask;
  }
}

int hashSetContains(THashSet set, unsigned int hash) {
  unsigned int arrayIndex = hash / 8, byteIndex = hash % 8;
  unsigned char mask = 1 << (7 - byteIndex);
  if (arrayIndex < HASH_SET_CAPACITY) {
    return (set[arrayIndex] & mask) > 0;
  } else {
    return 0;
  }
}

