
#ifndef __MAZE_H__
#define __MAZE_H__

#define MAX_MAZE_SIZE           16
#define MAX_MAZE_SIZE_MINUS_ONE 15

#define WALL_NOT_KNOWN    0
#define WALL_IS_THERE     1
#define WALL_IS_NOT_THERE 2

#define DIRECTION_DOWN  1
#define DIRECTION_LEFT  2
#define DIRECTION_UP    4
#define DIRECTION_RIGHT 8

#define KNOWN_DIRECTION_DOWN  16
#define KNOWN_DIRECTION_LEFT  32
#define KNOWN_DIRECTION_UP    64
#define KNOWN_DIRECTION_RIGHT 128
#define KNOWN_ALL_DIRECTIONS  240

//
// definicie typov
//
typedef unsigned char TDirection, TWallInfo, TCellInfo;

struct RobotPosition {
  unsigned int x, y;
  TDirection direction;
};
typedef struct RobotPosition TRobotPosition;

struct Maze {
  TWallInfo walls[MAX_MAZE_SIZE_MINUS_ONE][MAX_MAZE_SIZE];
  TRobotPosition robot;
};
typedef struct Maze TMaze;

//
// definicie funkcii
//
TMaze* mazeGet();                                   // pre schopnost pracovat s globalnou premennou maze v inych unitoch
void mazeInitialize();                              // inicializacia bludiska - vola sa na zaciatku
TCellInfo mazeCell(unsigned int x, unsigned int y); // zistenie informacii o stenach pre bunku X, Y

void addPercept(TCellInfo percept);                                // pridanie perceptu na aktualnu poziciu a rotaciu robota
TCellInfo rotatePercept(TCellInfo percept, unsigned int rotation); // otacanie perceptu - mozne pouzit aj na otocenie smeru

int getFinishCoords(unsigned int *x, unsigned int *y); // najdenie ciela, ak existuje

#endif
