
#include "Queue.h"
#include <stdlib.h>

void queueInitialize(TQueue *queue) {
  queue->head = NULL;
  queue->tail = NULL;
}

int queueIsEmpty(TQueue *queue) {
  return queue->head == NULL;
}

void queueAdd(TQueue *queue, unsigned int item) {
  // vytvorenie novej polozky
  TQueueItem* newItem = (TQueueItem *) malloc(sizeof(TQueueItem));
  newItem->data = item;
  newItem->next = NULL;

  // priradenie
  if (queue->head == NULL) {
    queue->head = newItem;
  } else {
    queue->tail->next = newItem;
  }
  queue->tail = newItem;
}

unsigned int queuePop(TQueue *queue) {
  if (queue->head == NULL) {
    return NULL;
  }

  // zapamatanie dat z hlavicky
  unsigned int item = queue->head->data;
  TQueueItem *next = queue->head->next;

  // uvolnenie pamate a vratenie dat
  free(queue->head);
  queue->head = next;
  return item;
}

void queueFreeItems(TQueue *queue) {
  while (queue->head != NULL) {
    queuePop(queue);
  }
}
