
#include "Stack.h"
#include <stdlib.h>

void stackInitialize(TStack *stack) {
  stack->head = NULL;
}

int stackIsEmpty(TStack *stack) {
  return stack->head == NULL;
}

void stackPush(TStack *stack, TDirection item) {
  TStackItem* newItem = (TStackItem *) malloc(sizeof(TStackItem));
  newItem->data = item;
  newItem->next = stack->head;
  stack->head = newItem;
}

TDirection stackPop(TStack *stack) {
  if (stack->head == NULL) {
    return 0;
  }
  TDirection result = stack->head->data;
  TStackItem* item = stack->head;
  stack->head = stack->head->next;
  free(item);
  return result;
}

void stackFreeItems(TStack *stack) {
  while (stack->head != NULL) {
    stackPop(stack);
  }
}
