#include <stdlib.h>
#include "../library/motor_led/e_motors.h"


void drive(int lspeed, int rspeed, int stepcount) {
        int mode, count, l1, r1, l2 = 0, r2 = 0, lastcount = 0;
        float f, g;

        int lm = (lspeed < 0 ? -1 : 1);
        int rm = (rspeed < 0 ? -1 : 1);

        lspeed = abs(lspeed);
        rspeed = abs(rspeed);

        e_set_steps_left(0);
        e_set_steps_right(0);

        if(lspeed > rspeed) {
                mode = 0;
        } else {
                mode = 1;
        }
        
        l1 = 100;
        r1 = 100;

        while(mode >= 0) {
                if(mode == 0) count = e_get_steps_left();
                else    count = e_get_steps_right();
                count = abs(count);

                if(l1 != l2) {
                        e_set_speed_left(l1 * lm);
                        lastcount = count;
                        l2 = l1;
                }

                if(r1 != r2) {
                        e_set_speed_right(r1 * rm);
                        lastcount = count;
                        r2 = r1;
                }

                if(count >= stepcount) {
                        mode = -1;
                }

                if(count - lastcount > 5) {
                        f = 2 * (float)count / stepcount;
        
                        if(f > 1)       f = 2 - f;

                        g = 1-f;
                        f = 1 - (g*g*g*g*g*g*g*g);
        
                        l1 = (int)(lspeed * f);
                        r1 = (int)(rspeed * f);
                }
        }

        e_set_speed_left(0);
        e_set_speed_right(0);
}
