#include <stdlib.h>
#include <stdio.h>

#include "CuTest.h"

CuSuite* MazeTestsGetSuite();
CuSuite* HashingTestsGetSuite();
CuSuite* QueueTestsGetSuite();
CuSuite* StackTestsGetSuite();
CuSuite* BFSearchTestsGetSuite();

void RunAllTests(void) {
  CuString *output = CuStringNew();
  CuSuite* suite = CuSuiteNew();

  CuSuiteAddSuite(suite, MazeTestsGetSuite());
  CuSuiteAddSuite(suite, HashingTestsGetSuite());
  CuSuiteAddSuite(suite, QueueTestsGetSuite());
  CuSuiteAddSuite(suite, StackTestsGetSuite());
  CuSuiteAddSuite(suite, BFSearchTestsGetSuite());

  CuSuiteRun(suite);
  CuSuiteSummary(suite, output);
  CuSuiteDetails(suite, output);
  printf("%s\n", output->buffer);
}

int main(void) {
  RunAllTests();
  return 0;
}
