#include "CuTest.h"
#include "../Queue.h"
#include <stdlib.h>

void QueueTest1(CuTest *tc) {
  // prazdna fronta
  TQueue queue;
  queueInitialize(&queue);
  CuAssertTrue(tc, queueIsEmpty(&queue));

  // vkladanie do fronty
  queueAdd(&queue, 5);
  CuAssertTrue(tc, !queueIsEmpty(&queue));
  queueAdd(&queue, 8);
  queueAdd(&queue, 11);
  queueAdd(&queue, 9);

  // vybratie z fronty
  CuAssertTrue(tc, !queueIsEmpty(&queue));
  CuAssertIntEquals(tc, 5, queuePop(&queue));
  CuAssertIntEquals(tc, 8, queuePop(&queue));
  CuAssertTrue(tc, !queueIsEmpty(&queue));
  CuAssertIntEquals(tc, 11, queuePop(&queue));
  CuAssertIntEquals(tc, 9, queuePop(&queue));
  CuAssertTrue(tc, queueIsEmpty(&queue));
}

CuSuite* QueueTestsGetSuite() {
  CuSuite* suite = CuSuiteNew();
  SUITE_ADD_TEST(suite, QueueTest1);
  return suite;
}
