#include "CuTest.h"
#include "../Stack.h"
#include <stdlib.h>

void StackTest1(CuTest *tc) {
  // prazdna fronta
  TStack stack;
  stackInitialize(&stack);
  CuAssertTrue(tc, stackIsEmpty(&stack));

  // vkladanie do fronty
  stackPush(&stack, 5);
  CuAssertTrue(tc, !stackIsEmpty(&stack));
  stackPush(&stack, 8);
  stackPush(&stack, 11);
  stackPush(&stack, 9);

  // vybratie z fronty
  CuAssertTrue(tc, !stackIsEmpty(&stack));
  CuAssertIntEquals(tc, 9, stackPop(&stack));
  CuAssertIntEquals(tc, 11, stackPop(&stack));
  CuAssertTrue(tc, !stackIsEmpty(&stack));
  CuAssertIntEquals(tc, 8, stackPop(&stack));
  CuAssertIntEquals(tc, 5, stackPop(&stack));
  CuAssertTrue(tc, stackIsEmpty(&stack));
}

CuSuite* StackTestsGetSuite() {
  CuSuite* suite = CuSuiteNew();
  SUITE_ADD_TEST(suite, StackTest1);
  return suite;
}
